#ifndef BITSET_UTILITY_H_
#define BITSET_UTILITY_H_

typedef unsigned char byte;

struct Bitset
{
	byte* bytes;
	unsigned int numBits;
};

void printBitset(unsigned char* bitset, int byteCount);

void setBytesInBitset(unsigned char* bitset,
					  int byteIndex,
					  int byteCount,
					  const void* bytes);

unsigned long long getValueFromBitset(const unsigned char* bitset,
									  int byteIndex,
									  int byteCount);

int variableByteEncode(unsigned char* bitset, unsigned long long byteIndex, unsigned long long value);
int variableByteEncode(unsigned char* bitset, unsigned long long byteIndex, long long value);
unsigned long long variableByteDecode(const unsigned char* bitset, unsigned long long byteIndex, int* byteCount);
long long variableByteDecodeSigned(const unsigned char* bitset, unsigned long long byteIndex, int* byteCount);
int getVariableByteEncodedByteCount(unsigned long long value);
int getVariableByteEncodedByteCount(long long value);

bool getBitAt(unsigned char* bitset, int bitIndex);
void setBitAt(unsigned char* bitset, int bitIndex, bool value);
bool getBitAt(Bitset& bitset, int bitIndex);
void setBitAt(Bitset& bitset, int bitIndex, bool value);
void bitwiseAnd(Bitset& byteArray1, Bitset& byteArray2, Bitset* result);
bool areEqual(Bitset& bitset1, Bitset& bitset2);
void setBitsetValues(Bitset& bitset, bool value);

#endif // BITSET_UTILITY_H_
