﻿#ifndef CFP_TREE_H_
#define CFP_TREE_H_

#include "CfpTreeMemoryManager.h"
#include "MultiBuffer.h"
#include "DatasetPreprocessor.h"
#include "CfpTreeUtility.h"
#include "../FimLogger/Logger.h"

class CfpTree
{
private:
	CfpTreeMemoryManager** memoryManager;
	MultiBuffer** multiBuffers;
	DatasetPreprocessor* datasetPreprocessor;
	double minSup;
	int numThreads;
	LogData* logData;

	unsigned char* rootNode = NULL;

	void insertTransaction(unsigned int* items, unsigned int itemCount);
	bool handleEmbeddedLeafNode(unsigned char** currentNode,
								UncompressedNode& unode,
								PointedByInfo& pointedByInfo,
								unsigned int& currentDeltaItem,
								unsigned int itemCount,
								unsigned int currentItemIndex,
								int threadNr);
	bool handleChainNode(unsigned char** currentNode,
						 UncompressedNode& unode,
						 PointedByInfo& pointedByInfo,
						 unsigned int& currentDeltaItem,
						 unsigned int& delta,
						 unsigned int* items,
						 unsigned int itemCount,
						 unsigned int& currentItemIndex,
						 int threadNr);
public:
	CfpTree(MultiBuffer** multiBuffers,
			DatasetPreprocessor* datasetPreprocessor,
			LogData* logData);
	~CfpTree();

	void buildTree();
	unsigned char* getRootNode();
};

#endif // CFP_TREE_H_
