#ifndef DATASET_PREPROCESSOR_H_
#define DATASET_PREPROCESSOR_H_

#include "MultiBuffer.h"

#include <cstdlib>

int compareItem(const void* itemIdA, const void* itemIdB);

class DatasetPreprocessor
{
private:
	MultiBuffer** multiBuffers;
	double minSup;
	int numThreads;
	int* initialToRemapId;
	int* remapToInitialId;
	int supportBufferSize = 0;
	static int longestTransaction;
	int transactionCount = 0;

	void countSupport();
	void getMaxIdAndLongestTransaction(int* maxId, int* longestTransaction);
	void remapItemsByFrequency();
public:
	static int* supportCount;

	DatasetPreprocessor(MultiBuffer **multiBuffers, double minSup, int numThreads);
	~DatasetPreprocessor();

	int* getRemapToInitialIdArray();
	int* getInitialToRemapIdArray();
	int getMinNumTransactions();
	int getNumItems();
	int getTransactionCount();
	static int getLongestTransaction();
	double getMinSup();
	int getNumThreads();
};

#endif // DATASET_PREPROCESSOR_H_
