#ifndef FP_GROWTH_MINER_
#define FP_GROWTH_MINER_

#include "Miner.h"
#include "FPTree.h"
#include "ShaFemMiner.h"
#include "CustomVector.h"
#include "HashTable.h"

class FPGrowthMiner : public Miner
{
private:
	StackMemoryManager** memoryManagers;

	void startMineFPTree();
	void mineFPTree(FPTree* tree, int* suffix, int suffixSize);
	void constructConditionalFpTree(FPNode* firstNode, FPTree* fpTree);
	int constructConditionalFpTree(unsigned int initialItem, FPTree* fpTree);
	int calculateSupportForFpTree(CalculateSupportCountContext* context);
	int calculateSupportForFPTreeNonSinglePath(FPNode* bottomNode, int forItem);
	void joinTwoArrays(int* array1, int sizeArray1, int* array2, int sizeArray2, int* destination);
	void addRestOfItemsToFrequentItemsets(CustomVector<int>* items,
										  int* currentItemset,
										  int currentItemsetSize,
										  int (FPGrowthMiner::*calcSupport)(CalculateSupportCountContext*),
										  CalculateSupportCountContext* context);
public:
	FPGrowthMiner(CfpArray* cfpArray, int numThreads, LogData* logData);
	~FPGrowthMiner();

	void startMining();
};

#endif // FP_GROWTH_MINER_
