#ifndef MINER_H_
#define MINER_H_

#include "CfpArray.h"
#include "ItemsetStack.h"
#include "../FimLogger/Logger.h"

#include <vector>
#include <string>
using std::string;

struct Itemset
{
	unsigned int* items;
	unsigned int itemCount;
	double support;
};

class Miner
{
protected:
	CfpArray& cfpArray;
	LogData* logData;
	int numThreads;
	double minSup;
	int numTransactions;
	int minNumTransactions;
	ItemsetStack** itemsetStacks;

	bool addToFrequentItemsets(int threadNr, int* items, unsigned int itemCount, int supportCount);
public:
	Miner(CfpArray* cfpArray, int numThreads, LogData* logData);
	virtual ~Miner();

	virtual void startMining() = 0;
	void writeResults(string path);
	void reportNumberOfFrequentItemsetsFound();
};

#endif // MINER_H_
