#ifndef STACK_MEMORY_MANAGER_H_
#define STACK_MEMORY_MANAGER_H_

class StackMemoryManager
{
private:
	const long long MEMORY_BUFFER_SIZE = 128 * 1024 * 1024;
	const int BUFFER_COUNT = ((long long)20 * 1024 * 1024 * 1024) / MEMORY_BUFFER_SIZE;
	unsigned char** memoryBuffers;
	unsigned int currentBufferNr;
	long long currentByteIndexInBuffer;
public:
	StackMemoryManager();
	~StackMemoryManager();

	unsigned char* grow(long long byteCount);
	void shrink(long long byteCount);
	unsigned long long getMemoryUsage();
	unsigned int getCurrentBufferNr();
	long long getCurrentByteIndexInBuffer();
	void setToPreviousState(unsigned int bufferNr, long long byteIndexInBuffer);
};


#endif /* STACK_MEMORY_MANAGER_H_ */
