#include "DatasetGenerator.h"

#include <iostream>
using std::cout;
using std::endl;

#include <string>
using std::string;

string intToString(int value)
{
	if (value >= 10000000)
		return std::to_string(value / 1000000) + "M";
	else if (value >= 10000)
		return std::to_string(value / 1000) + "K";
	else
		return std::to_string(value);
}

void createPathString(string& path, InputData inputData)
{
	path = "T" + intToString(inputData.numTransactions);
	path += "-A" + intToString(inputData.averageTransactionLength);
	path += "-I" + intToString(inputData.numUniqueItems);
	path += "-M" + intToString(inputData.maxspan);
	path += ".dat";
}

int main(int argc, char** argv)
{
	InputData inputData;
	string path = "";

	if (argc == 1)
	{
		cout << "numTransactions: \t\t -n # \t default: " << inputData.numTransactions << endl;
		cout << "averageTransactionLength: \t -a # \t default: " << inputData.averageTransactionLength << endl;
		cout << "numUniqueItems: \t\t -u # \t default: " << inputData.numUniqueItems << endl;
		cout << "maxspan: \t\t\t -m # \t default: " << inputData.maxspan << endl;
		cout << "numThreads: \t\t\t -t # \t default: " << inputData.numThreads << endl;
		return 0;
	}

	for (int i = 1; i < argc; i++)
	{
		if (string(argv[i]) == "-t")
		{
			inputData.numThreads = std::atoi(argv[i + 1]);
		}
		else if (string(argv[i]) == "-a")
		{
			inputData.averageTransactionLength = std::atoi(argv[i + 1]);
		}
		else if (string(argv[i]) == "-n")
		{
			inputData.numTransactions = std::atoi(argv[i + 1]);
		}
		else if (string(argv[i]) == "-u")
		{
			inputData.numUniqueItems = std::atoi(argv[i + 1]);
		}
		else if (string(argv[i]) == "-m")
		{
			inputData.maxspan = std::atoi(argv[i + 1]);
		}
		else if (string(argv[i]) == "-o")
		{
			path = argv[i + 1];
		}
	}

	DatasetGenerator dg(inputData);
	createPathString(path, inputData);
	dg.writeToPath(path);
}
