#ifndef EMBARRASSINGLY_PARALLEL_MINER_H_
#define EMBARRASSINGLY_PARALLEL_MINER_H_

#include "Miner.h"

class EmbarrassinglyParallelMiner : public Miner
{
private:
	void indexBTFITI();
	void depthFirst(ExtendedItemset &itemset, ExtendedItemset &tail, int threadNr);

	void addAllSubsumeSets(unsigned int* items,
						   unsigned int itemCount,
						   unsigned int* subsume,
						   unsigned int subsumeCount,
						   unsigned char* dimensionalAttributes,
						   double support,
						   int threadNr);
	void combineItemsSubsumeAndTail(unsigned int* items,
									unsigned int itemCount,
									unsigned int* subsume,
									unsigned int subsumeCount,
									unsigned char* dimensionalAttributes,
									ExtendedItemset& tail,
									int threadNr);
public:
	EmbarrassinglyParallelMiner(StackMemoryManager** memoryManagers,
								DatasetPreprocessor& datasetPreprocessor,
								BitTable& bitTable,
								IndexArray& indexArray,
								InputData& inputData,
								LogData& logData);
	~EmbarrassinglyParallelMiner();
};

#endif // EMBARRASSINGLY_PARALLEL_MINER_H_
