#ifndef INDEX_ARRAY_H_
#define INDEX_ARRAY_H_

#include "StackMemoryManager.h"
#include "BitTable.h"
#include "Utility.h"
#include "DatasetPreprocessor.h"

struct IndexArrayElement
{
	unsigned int* subsume;
	unsigned int itemCount;
	unsigned int item;
};

class IndexArray
{
private:
	StackMemoryManager** memoryManagers;
	BitTable& bitTable;
	InputData& inputData;
	DatasetPreprocessor& datasetPreprocessor;
	LogData& logData;
	IndexArrayElement* elements;

	void createIndexArray();
public:
	IndexArray(StackMemoryManager** memoryManagers,
			   BitTable& bitTable,
			   InputData& inputData,
			   DatasetPreprocessor& datasetPreprocessor,
			   LogData& logData);
	~IndexArray();

	unsigned long long getMemoryUsageInBytes() const;
	int getNumElements() const;
	IndexArrayElement* getElements() const;
};

#endif // INDEX_ARRAY_H_
