#ifndef STACK_MEMORY_MANAGER_H_
#define STACK_MEMORY_MANAGER_H_

class StackMemoryManager
{
private:
	static const long long MEMORY_BUFFER_SIZE = 128 * 1024 * 1024;
	static const int BUFFER_COUNT = ((long long)20 * 1024 * 1024 * 1024) / MEMORY_BUFFER_SIZE;
	unsigned char** memoryBuffers;
	unsigned int currentBufferNr;
	long long currentByteIndexInBuffer;
public:
	StackMemoryManager();
	~StackMemoryManager();

	unsigned char* grow(long long byteCount);
	void shrink(long long byteCount);
	unsigned long long getMemoryUsageInBytes() const;
};

#endif /* STACK_MEMORY_MANAGER_H_ */
