#ifndef BITSET_UTILITY_H_
#define BITSET_UTILITY_H_

void printBitset(unsigned char* bitset, int byteCount);

void setBytesInBitset(unsigned char* bitset,
					  int byteIndex,
					  int byteCount,
					  const void* bytes);

unsigned long long getValueFromBitset(const unsigned char* bitset,
									  int byteIndex,
									  int byteCount);

bool getBitAt(const unsigned char* bitset, const int bitIndex);
void setBitAt(unsigned char* bitset, int bitIndex, bool value);

unsigned long long getNumBytes(unsigned long long numBits);
void zeroBytes(unsigned char* bytes, int numBytes);
void intersectBitsets(const unsigned char* bitset1,
					  const unsigned char* bitset2,
					  const unsigned long long byteCount,
					  unsigned char* result);
unsigned long long popcount(const unsigned char* bitset,
							const long long bitCount);

#endif // BITSET_UTILITY_H_
