#ifndef DATASET_PREPROCESSOR_H_
#define DATASET_PREPROCESSOR_H_

#include "MultiBuffer.h"

#include <cstdlib>

int compareItem(const void* itemIdA, const void* itemIdB);

class DatasetPreprocessor
{
private:
	MultiBuffer** multiBuffers;
	double minSup;
	int numThreads;
	int supportBufferSize = 0;
	int longestTransaction = 0;
	int transactionCount = 0;
	int* numTransactionsForThread;
	int numTransactionsWithFrequentItems = 0;

	void countSupport();
	void getMaxIdAndLongestTransaction(int* maxId, int* longestTransaction);
	void countTransactionsWithFrequentItems();
public:
	static int* supportCount;

	DatasetPreprocessor(MultiBuffer **multiBuffers, double minSup, int numThreads);
	~DatasetPreprocessor();

	int getSupportBufferSize();
	int getMinNumTransactions();
	int getNumItems();
	int getTransactionCount();
	int getLongestTransaction();
	double getMinSup();
	int getNumThreads();
	int getNumTransactionsForThread(int threadNr);
	int getNumTransactionsWithFrequentItems();
};

#endif // DATASET_PREPROCESSOR_H_
