#ifndef ECLAT_MINER_H_
#define ECLAT_MINER_H_

#include "VerticalDataLayout.h"
#include "ItemsetStack.h"
#include "EquivalenceClassStack.h"
#include "DatasetPreprocessor.h"
#include "../FimLogger/Logger.h"

#include <string>
using std::string;

class EclatMiner
{
protected:
	VerticalDataLayout& verticalDataLayout;
	DatasetPreprocessor& datasetPreprocessor;
	LogData& logData;
	ItemsetStack** itemsetStack;
	EquivalenceClassStack** equivalenceClassStack;
	int numThreads;

	void addToFrequentItemsets(int itemCount, unsigned int* items, double support);
public:
	EclatMiner(VerticalDataLayout& verticalDataLayout,
			   DatasetPreprocessor& datasetPreprocessor,
			   LogData& logData);
	virtual ~EclatMiner();

	void writeResults(string path) const;
	void reportNumberOfFrequentItemsetsFound() const;
	virtual void startMining() = 0;
};

#endif // ECLAT_MINER_H_
