#ifndef EQUIVALENCE_CLASS_STACK_H_
#define EQUIVALENCE_CLASS_STACK_H_

#include "StackMemoryManager.h"


class EquivalenceClassStack
{
private:
	StackMemoryManager memoryManager;
	const int NUM_BITMAP_BYTES;
	int equivalenceClassCount;
	unsigned int* topItemCountAddress;
public:
	EquivalenceClassStack(unsigned int numBitmapBytes);
	void push(unsigned int itemCount, unsigned int* item, unsigned char* tidBitmap);
	void pushEmpty(unsigned int itemCount, unsigned int** itemAddress, unsigned char** tidBitmapAddress);
	void top(unsigned int** itemCount, unsigned int** items, unsigned char** tidBitmap) const;
	void pop();
	int size() const;
	unsigned long long getMemoryUsageInBytes() const;
};

#endif // EQUIVALENCE_CLASS_STACK_H_
