#ifndef HYBRID_CLASS_MINER_H_
#define HYBRID_CLASS_MINER_H_

#include "EclatMiner.h"
#include "VerticalDataLayout.h"
#include "DatasetPreprocessor.h"
#include "../FimLogger/Logger.h"

#include <omp.h>
#include <vector>
using std::vector;

class HybridClassMiner : public EclatMiner
{
private:
	vector<int> freeThreads;
	omp_lock_t masterLock;

	void mine(int nextIndex, int threadNr);
	void addFreeThread(int threadNr);
	void removeFreeThread(int threadNr);
public:
	HybridClassMiner(VerticalDataLayout& verticalDataLayout,
					 DatasetPreprocessor& datasetPreprocessor,
					 LogData& logData);
	~HybridClassMiner();
	void startMining();
};

#endif // HYBRID_CLASS_MINER_H_
