#include "ItemsetStack.h"

#include <cstdlib>

ItemsetStack::ItemsetStack()
{
	itemsetCount = 0;
	topItemCountAddress = NULL;
}

/***** PUBLIC FUNCTIONS *****/

unsigned int* ItemsetStack::push(unsigned int itemCount, double support)
{
	unsigned long long sizeofItems = itemCount * sizeof(unsigned int);
	unsigned long long sizeofSupport = sizeof(double);
	unsigned long long sizeofItemCount = sizeof(unsigned int);

	unsigned long long memoryChunkSize = sizeofItems + sizeofSupport + sizeofItemCount;;
	unsigned char* itemAddress = memoryManager.grow(memoryChunkSize);

	double* supportAddress = (double*)(itemAddress + sizeofItems);
	*supportAddress = support;

	topItemCountAddress = (unsigned int*)(itemAddress + sizeofItems + sizeofSupport);
	*topItemCountAddress = itemCount;

	itemsetCount++;

	return (unsigned int*)itemAddress;
}

void ItemsetStack::top(unsigned int** itemCount, double** support, unsigned int** items) const
{
	*itemCount = topItemCountAddress;
	*support = (double*)((unsigned char*)topItemCountAddress - sizeof(double));
	*items = (unsigned int*)((unsigned char*)topItemCountAddress - sizeof(double) - (**itemCount) * sizeof(unsigned int));
}

void ItemsetStack::pop()
{
	unsigned int itemCount = *topItemCountAddress;
	long long shrinkAmount = itemCount * sizeof(unsigned int) + sizeof(double) + sizeof(unsigned int);
	memoryManager.shrink(shrinkAmount);
	topItemCountAddress = (unsigned int*)((unsigned char*)topItemCountAddress - shrinkAmount);

	itemsetCount--;
}

int ItemsetStack::size() const
{
	return itemsetCount;
}

unsigned long long ItemsetStack::getMemoryUsageInBytes() const
{
	return memoryManager.getMemoryUsageInBytes();
}
