#ifndef UTILITY_H_
#define UTILITY_H_

#include <string>
using std::string;

double calculateSupport(unsigned int supportCount, unsigned int transactionCount);
void arrayCopy(unsigned int* src, unsigned int* dst, unsigned int size);

enum MiningMethod
{
	INDEPENDENT_CLASS,
	HYBRID
};

struct InputData
{
	string datasetPath = "";
	double minSup = 0.1;
	int numThreads = 1;
	bool writeOutput = false;
	MiningMethod miningMethod = INDEPENDENT_CLASS;
	string inputFile = "";
	string logFilePath = "stats.txt";
	int repetition = -1;
};

#endif // UTILITY_H_
