#ifndef MULTI_BUFFER_H_
#define MULTI_BUFFER_H_

#include "Utility.h"

/*
This is a buffer that contains multiple buffers.
The amount of buffers created are dependent on the 
byte count and buffer size.
*/
class MultiBuffer
{
	private:
		int numBytes;
		int numBuffers;
		int numBuffersAdded;
		byte** buffers;

		int getBufferIndex(const int* byteNr);
		int getByteIndex(const int* byteNr);
		void removeBuffer(const int* bufferIndex);
	public:
		static const int BUFFER_SIZE = 1024 * 1024;

		MultiBuffer(int numBytes);
		~MultiBuffer();

		void addBuffer(byte* buffer);
		byte getByte(const int* byteNr);
		byte getByteAndDelete(const int* byteNr);
		int getNumBuffers();
		int getNumBytes();
};

#endif /* MULTI_BUFFER_H_ */