#ifndef PRE_PROCESSOR_H_
#define PRE_PROCESSOR_H_

#include "MultiBuffer.h"

class PreProcessor
{
	private:
		const int NUM_THREADS;
		MultiBuffer** multiBuffers;

		static int countListBufferSize;
		static int** localCountLists;
		static int* globalCountList;
		static int* initialToRemapId;
		static int* remapToInitialId;

		int numberOfTransactions;
		static int maxTransactionLength;

		void getDatasetInformation(int* maxId, int* maxTransactionLength, int* transactionCount) const;
		void computeLocalCountLists();
		void computeGlobalCountList();
		void remapItemsByFrequency();
	public:
		PreProcessor(MultiBuffer** multiBuffers, int numThreads);
		~PreProcessor();

		static int compareItem(const void* itemdIdA, const void* itemIdB);
		static int* getGlobalCountList();
		static int* getLocalCountList(int threadNr);
		static int getCountListBufferSize();
		static int* getRemapToInitialIdArray();
		static int* getInitialToRemapIdArray();

		int getNumberOfTransactions();
		static int getMaxTransactionLength();
};

#endif /* PRE_PROCESSOR_H_ */
