#include "Utility.h"

#include <cmath>
#include <iostream>
using std::cout;
using std::endl;
#include <bitset>
#include <sstream>
#include <cstring>

void printBitset(unsigned char* bitset, int byteCount)
{
	for (int i = 0; i < byteCount; i++)
	{
		std::bitset<8> byte(bitset[i]);
		cout << byte << " ";
	}
	cout << endl;
}

void bitwiseAnd(Bitset& byteArray1, Bitset& byteArray2, Bitset* result)
{
	int numBytes = (int)ceil(result->numBits / 8.0);

	while (numBytes % 4 != 0)
	{
		numBytes--;
		result->bytes[numBytes] = byteArray1.bytes[numBytes] & byteArray2.bytes[numBytes];
	}

	uint32_t* array1 = (uint32_t*)byteArray1.bytes;
	uint32_t* array2 = (uint32_t*)byteArray2.bytes;
	uint32_t* r = (uint32_t*)result->bytes;
	numBytes /= 4;
	for (int i = numBytes; i-- > 0;)
		r[i] = array1[i] & array2[i];
}

int countOnes(Bitset& bitset)
{
	int numOnes = 0;
	for (unsigned int i = 0; i < bitset.numBits; i++)
	{
		if (getBitAt(bitset, i))
			numOnes++;
	}

	return numOnes;
}

bool getBitAt(Bitset& bitset, int bitIndex)
{
	int byteIndex = bitIndex / 8;
	int localIndex = bitIndex - (bitIndex / 8) * 8;
	return (bitset.bytes[byteIndex] & (0x80 >> localIndex)) != 0;
}

void setBitAt(Bitset& bitset, int bitIndex, bool value)
{
	int byteIndex = bitIndex / 8;
	int localIndex = bitIndex - (bitIndex / 8) * 8;

	if (value)
		bitset.bytes[byteIndex] |= (0x80 >> localIndex);
	else
		bitset.bytes[byteIndex] &= ~(0x80 >> localIndex);
}

bool areEqual(Bitset& bitset1, Bitset& bitset2)
{
	return memcmp(bitset1.bytes, bitset2.bytes, (int)ceil(bitset1.numBits / 8.0)) == 0;
}

void setBitsetValues(Bitset& bitset, bool value)
{
	for (unsigned int i = 0; i < bitset.numBits; i++)
		setBitAt(bitset, i, value);
}
