#include <string>
using std::string;

#ifndef UTILITY_H_
#define UTILITY_H_

typedef unsigned char byte;

struct Bitset
{
	byte* bytes;
	unsigned int numBits;
};

struct InputData
{
	string datasetPath = "";
	double minSup = 0.1;
	int numThreads = 1;
	bool writeOutput = false;
	string inputFile = "";
	string logFilePath = "stats.txt";
	int repetition = -1;
};

void printBitset(unsigned char* bitset, int byteCount);

void bitwiseAnd(Bitset& byteArray1, Bitset& byteArray2, Bitset* result);
int countOnes(Bitset& bitset);
bool getBitAt(Bitset& bitset, int bitIndex);
void setBitAt(Bitset& bitset, int bitIndex, bool value);
bool areEqual(Bitset& bitset1, Bitset& bitset2);
void setBitsetValues(Bitset& bitset, bool value);

#endif /* UTILITY_H_ */
