#include "StockReader.h"

#include <dirent.h>
#include <string>
#include <fstream>
#include <sstream>
#include <iostream>
#include <vector>
using namespace std;

// http://runnable.com/VHb0hWMZp-ws1gAr/splitting-a-string-into-a-vector-for-c%2B%2B
vector<string> split(string str, char delimiter)
{
	vector<string> internal;
	stringstream ss(str); // Turn the string into a stream.
	string tok;

	while(getline(ss, tok, delimiter)) {
		internal.push_back(tok);
	}

	return internal;
}

void StockReader::readStockData(std::string folderLocation, vector<Stock*> &stocks)
{
	DIR* dpdf;
	struct dirent *epdf;

	dpdf = opendir(folderLocation.c_str());
	if (dpdf != NULL)
	{
		int id = 0;
		while (epdf = readdir(dpdf))
		{
			string name = epdf->d_name;
			if (name.substr(name.find_last_of(".") + 1) == "csv")
			{
				Stock* stock = new Stock(id, name);
				id += 2;
				stocks.push_back(stock);

				std::ifstream file(folderLocation + "/" + name);

				string line;
				while (std::getline(file, line))
				{
					vector<string> lineContent = split(line, ',');
					if (lineContent[0] == "Date")
						continue;
					stock->addData(lineContent[0], atof(lineContent[1].c_str()), atof(lineContent[4].c_str()));
				}

			}
		}
	}
}
