#include "StockWriter.h"

#include <iostream>
#include <fstream>
using namespace std;

unsigned int getNumTransactions(vector<Stock*> stocks)
{
	unsigned int numTransactions = -1;
	for (int i = 0; i < stocks.size(); i++)
	{
		if (stocks[i]->getNumData() < numTransactions)
			numTransactions = stocks[i]->getNumData();
	}

	return numTransactions;
}

void StockWriter::writeStocks(std::string path, vector<Stock*> stocks)
{
	ofstream file;
	file.open(path.c_str());

	unsigned int numTransactions = getNumTransactions(stocks);

	for (int i = 0; i < numTransactions; i++)
	{
		for (int j = 0; j < stocks.size(); j++)
		{
			if (stocks[j]->getClosingPrice(i) - stocks[j]->getOpeningPrice(i) > 0)
				file << stocks[j]->getId() << " ";
			else
				file << stocks[j]->getId() + 1 << " ";
		}
		file << endl;
	}

	file.close();
}

void StockWriter::writeInfo(string path, vector<Stock*> stocks)
{
	ofstream file;
	file.open(path.c_str());

	unsigned int numTransactions = getNumTransactions(stocks);
	file << "Time frame: " << stocks[0]->getDate(0) << " - " << stocks[0]->getDate(numTransactions - 1) << endl << endl;

	for (int i = 0; i < stocks.size(); i++)
	{
		file << stocks[i]->getId() << ": " << stocks[i]->getName() << " INCREASED" << endl;
		file << stocks[i]->getId()  + 1 << ": " << stocks[i]->getName() << " EQUAL OR DECREASED" << endl;
	}

	file.close();
}
